"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var crate_1 = require("./crate");
var target_1 = require("./target");
var build_settings_1 = require("./build-settings");
var log_1 = require("./log");
var child_process_1 = require("./async/child_process");
/** A Neon project and its directory tree. */
var Project = (function () {
    function Project(root, options) {
        if (options === void 0) { options = {}; }
        var _a = options.crate, crate = _a === void 0 ? 'native' : _a;
        this.root = root;
        this.crate = new crate_1.default(this, crate);
    }
    Project.prototype.build = function (toolchain, release, abi) {
        return __awaiter(this, void 0, void 0, function () {
            var target, settings;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        target = new target_1.default(this.crate, { release: release });
                        settings = build_settings_1.default.current(toolchain);
                        if (!!target.inState(settings)) return [3 /*break*/, 2];
                        log_1.default("forcing rebuild for new build settings");
                        return [4 /*yield*/, target.clean()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        // 2. Build the dylib.
                        log_1.default("running cargo");
                        return [4 /*yield*/, target.build(toolchain, settings, abi)];
                    case 3:
                        _a.sent();
                        // 3. Copy the dylib as the main addon file.
                        log_1.default("generating " + path.join(this.crate.subdirectory, this.crate.nodefile));
                        return [4 /*yield*/, this.crate.finish(target.dylib)];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Project.prototype.clean = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // 1. Do a `cargo clean` to delete the `target` directory.
                        log_1.default("cargo clean");
                        return [4 /*yield*/, child_process_1.spawn("cargo", ["clean"], { cwd: this.crate.root, stdio: 'inherit' })];
                    case 1:
                        _a.sent();
                        // 2. Remove the main addon file.
                        log_1.default("remove " + path.join(this.crate.subdirectory, this.crate.nodefile));
                        return [4 /*yield*/, this.crate.removeAddon()];
                    case 2:
                        _a.sent();
                        // 3. Clear the artifacts file.
                        this.crate.resetArtifacts();
                        this.crate.saveArtifacts();
                        return [2 /*return*/];
                }
            });
        });
    };
    return Project;
}());
exports.default = Project;
;
