"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var async = require("./async/child_process");
var child_process = require("child_process");
function toolchainPrefix(toolchain) {
    return toolchain === 'default' ? [] : ["+" + toolchain];
}
function spawnSync(tool, args, toolchain, options) {
    if (toolchain === void 0) { toolchain = 'default'; }
    return child_process.spawnSync(tool, toolchainPrefix(toolchain).concat(args), options);
}
exports.spawnSync = spawnSync;
function spawn(tool, args, toolchain, options) {
    if (toolchain === void 0) { toolchain = 'default'; }
    return async.spawn(tool, toolchainPrefix(toolchain).concat(args), options);
}
exports.spawn = spawn;
