import * as rust from './rust';
import Crate from './crate';
import BuildSettings from './build-settings';
export declare type TargetOptions = {
    release?: boolean;
    arch?: string;
};
/** The Rust build artifacts for a single build target of a Neon crate. */
export default class Target {
    readonly crate: Crate;
    readonly release: boolean;
    readonly arch: string;
    readonly triple: string;
    readonly subdirectory: string;
    readonly root: string;
    readonly dylib: string;
    constructor(crate: Crate, options?: TargetOptions);
    clean(): Promise<void>;
    build(toolchain: rust.Toolchain, settings: BuildSettings, abi?: string): Promise<number>;
    inState(settings: BuildSettings): boolean;
}
